Cgu::Callback::Callback0< T, FreeArgs > Class Template Reference

`#include <callback.h>`

Inheritance diagram for Cgu::Callback::Callback0< T, FreeArgs >:

## Public Types

typedef void(T::* | MemFunc )(FreeArgs...)

## Public Member Functions

void | dispatch (typename Cgu::Param< FreeArgs >::ParamType...free_args) const
| Callback0 (T &obj_, MemFunc func_)
Public Member Functions inherited from Cgu::Callback::CallbackArg< FreeArgs...>
| CallbackArg ()
virtual | ~CallbackArg ()

## Member Typedef Documentation

template<class T , class... FreeArgs>

typedef void(T::* Cgu::Callback::Callback0< T, FreeArgs >::MemFunc)(FreeArgs...)

## Constructor & Destructor Documentation

template<class T , class... FreeArgs>

Cgu::Callback::Callback0< T, FreeArgs >::Callback0 | ( | T & | obj_,
|  | MemFunc | func_
| ) |  |

inline

## Member Function Documentation

template<class T , class... FreeArgs>

void Cgu::Callback::Callback0< T, FreeArgs >::dispatch | ( | typename Cgu::Param< FreeArgs >::ParamType... | args | ) | const

inlinevirtual

This will execute the referenced function or class method encapsulated by this class. It will only throw if the dispatched function or class method throws, or if the copy constructor of a free or bound argument throws and it is not a reference argument. It is thread safe if the referenced function or class method is thread safe.

Parameters

  args | The unbound arguments to be passed to the referenced function or class method, if any.

Note
  We use dispatch() to execute the callback, because the callback would normally be invoked through a base class pointer. To invoke it through operator()(), use the FunctorArg wrapper class.

Implements Cgu::Callback::CallbackArg< FreeArgs...>.

The documentation for this class was generated from the following file:

- callback.h